include:
  - https://gitlab.com/Linaro/lkft/mirrors/retrigger-pipeline/-/raw/main/base.yml


stages:
  - download_prerequisites
  - fetch_reproducer
  - create_reproducer_plan
  - launch_reproducer


# If any job runs into unexpected Gitlab failure, retries it up to 2x
# Ref: https://docs.gitlab.com/ee/ci/yaml/#retry
.base_job:
  retry:
    max: 2
    when: runner_system_failure


download_prerequisites:
  extends: .base_job
  stage: download_prerequisites
  script: ./retrigger_utils/download_prerequisites.py
  artifacts:
    when: always
    paths:
      - './'


fetch_reproducer:
  extends: .base_job
  stage: fetch_reproducer
  script:
    - ./retrigger_utils/fetch_reproducer.py
  artifacts:
    when: always
    paths:
      - $TEST_REPRODUCER_FILE
      - $BUILD_REPRODUCER_FILE

create_reproducer_plan:
  extends: .base_job
  stage: create_reproducer_plan
  script:
    - ./retrigger_utils/create_plan.py
  artifacts:
    when: always
    paths:
      - $OUTPUT_REPRODUCER_FILE

launch_reproducer:
  extends: .base_job
  stage: launch_reproducer
  script:
    - python retrigger_utils/launch_reproducer.py
    # Quotes are required around the curl request to prevent the colon ':' character causing yaml error.
    - 'curl -X POST ${QA_SERVER}/api/createbuild/${QA_TEAM}/${QA_PROJECT}/${SQUAD_BUILD_NAME} -H "Auth-Token: ${QA_REPORTS_TOKEN}"'
    - export BUILD_ID=${SQUAD_BUILD_NAME}
    - regbot_url="https://regbot.lkft.org"
    - export CALLBACK_URL="${regbot_url}/retrigger_result?group=${QA_TEAM}&project=${QA_PROJECT}&version=${SQUAD_BUILD_NAME}"
    - bash -xve register-callback.sh
  artifacts:
    when: always
    paths:
      - $OUTPUT_REPRODUCER_FILE
